异常机制

xiaoxiao2021-03-01  5

      Java的异常处理是通过5个关键字来实现的:try,catch,throw,throws,finally。 1、概念      try语句         try语句用大括号{}指定了一段代码,该段代码可能会抛弃一个或多个例外。           catch语句         catch语句的参数类似于方法的声明,包括一个例外类型和一个例外对象。例外类型必须为Throwable类的子类,它指明了catch语句所处理的例外类型,例外对象则由运行时系统在try所指定的代码块中生成并被捕获,大括号中包含对象的

处理,其中可以调用对象的方法。           catch语句可以有多个,分别处理不同类的例外。Java运行时系统从上到下分别对每个catch语句处理的例外类型进行

检测,直到找到类型相匹配的catch语句为止。这里,类型匹配指catch所处理的例外类型与生成的例外对象的类型完全一

致或者是它的父类,因此,catch语句的排列顺序应该是从特殊到一般。           也可以用一个catch语句处理多个例外类型,这时它的例外类型参数应该是这多个例外类型的父类,程序设计中要根据

具体的情况来选择catch语句的例外处理类型。            finally语句         try所限定的代码中,当抛弃一个例外时,其后的代码不会被执行。通过finally语句可以指定一块代码。无论try所指

定的程序块中抛弃或不抛弃例外,也无论catch语句的例外类型是否与所抛弃的例外的类型一致,finally所指定的代码都

要被执行,它提供了统一的出口。通常在finally语句中可以进行资源的清除工作。如关闭打开的文件等。           throws语句         throws总是出现在一个函数头中,用来标明该成员函数可能抛出的各种异常。对大多数Exception子类来说,Java 编译器会强迫你声明在一个成员函数中抛出的异常的类型。如果异常的类型是Error或 RuntimeException, 或它们的子类,这个规则不起作用, 因为这在程序的正常部分中是不期待出现的。 如果你想明确地抛出一个RuntimeException,你必须用throws语句来声明它的类型。           throw语句         throw总是出现在函数体中,用来抛出一个异常。程序会在throw语句后立即终止,它后面的语句执行不到,然后在包

含它的所有try块中(可能在上层调用函数中)从里向外寻找含有与其匹配的catch子句的try块。

      class myException extends Exception{        String msg;        myException(int age){        msg="age can not be positive!";        }        public String toString(){        return msg;        }        }

      class Age{        public void intage(int n) throws myException{//        if(n<0||n>120){        myException e=new myException(n);        throw e; //是一个转向语句,抛出对象实例,停止执行后面的代码        }        if(n>=0){        System.out.print("合理的年龄!");        }      }         public static void main(String args[]) {        int a=-5;        try { //try catch 必需有        Age age = new Age();        age.intage(a);//触发异常        System.out.print("抛出异常后的代码") ;//这段代码是不会被执行的,程序已经被转向        } catch (myException ex) {        System.out.print(ex.toString());      }      finally{//无论抛不抛异常,无论catch语句的异常类型是否与所抛出的例外的类型一致,finally所指定的代码都

要被执行,它提供了统一的出口。        System.out.print("进入finally! ");        }        }      }

结果:年龄非法! 进入finally!

 

又如:      void fun()throws IOException,SQLException      {      ...      } 这表示 fun方法可能会丢两个异常出来,那么在调用fun的时候就会做好准备,比如可以这样       try       {       fun();       }catch(IOException e)       {       }catch(SQLException e)       {

      }

 

2、throw和throws区别

 

区别一:

 

      throw 是语句抛出一个异常,throw出现在函数体;throw语法:throw <异常对象>

 

      throws是方法抛出一个异常;throws出现在方法函数头;throws语法:[<修饰符>]<返回值类型><方法名>([<参数列表>])[throws<异常类>]      在方法声明中,添加throws子句表示该方法将抛出异常。      其中:异常类可以声明多个,用逗号分割。

区别二:

 

      throws可以单独使用,但throw不能;

 

      throw要么和try-catch-finally语句配套使用,要么与throws配套使用。但throws可以单独使用,然后再由处理异常的方法捕获。

区别三:

 

      throws表示出现异常的一种可能性,并不一定会发生这些异常;      throw则是抛出了异常,执行throw则一定抛出了某种异常;

 

      throws E1,E2,E3 只是告诉程序这个方法可能会抛出这些个异常,方法的调用者可能要处理这些异常。而这些异常E1,E2,E3可能是该函数体产生的。

      而throw是明确之处这个地方要抛出这个异常。

 

      void doA() throws Exception1, Exception3 {        try {        ……        } catch(Exception1 e) {        throw e;        } catch(Exception2 e) {        System.out.println("出错了");        }        if (a != b)        throw new Exception3("自定义异常");      }

      代码块……中可能产生异常Exception1、Exception2和Exception3。      如果产生Exception1异常,则捕捉了之后抛出由该方法的调用者去做处理;      如果产生Exception2异常,则该方法自己做了处理(打印出了说出错了),所以该方法就不会再向外抛出Exception2异常了,void doA() throws Exception1,,Excpetion3里面的Exception2也就不用写了;而Exception3异常是该方法的某段逻辑出错,程序员自己作了处理在该段逻辑错误的情况下抛出异常Exception3,则调用者也需要处理。

      throw是具体向外抛异常的动作,所以它是抛出一个异常实例。语句用在方法体内,表示抛出异常,由方法体内的语句处

理;       throws主要是声明这个方法会抛出这种类型的异常,使其他地方调用它时知道要捕获这个异常。语句用在方法声明后

面,表示再抛出异常,由调用这个方法的上一级方法中的语句来处理;

同时:       两者都是消极处理异常的方式(这里的消极并不是说这种方式不好),只是抛出或者可能抛出异常,但是不会由函数

去处理异常,真正的处理异常由函数的上层调用处理。

 

转载请注明原文地址: https://www.6miu.com/read-3850113.html

最新回复(0)